      subroutine calcincoh(ki,kf,incohmon,incohana)
      implicit none

c...	passed variables
      real  ki(2),kf(2)
      real incohmon(2),incohana(2)

c...	local variables      
      real ki_incoh(2),kf_incoh(2), ratio
      integer i

C  calculate the ratio of lengths of wavevectors.
      ratio=sqrt(ki(1)**2.0+ki(2)**2.0)/sqrt(kf(1)**2.0+kf(2)**2.0)
C  Calculate ki_incoh with length kf
      do i=1,2
        ki_incoh(i)=ki(i)/ratio
        kf_incoh(i)=kf(i)*ratio
        incohmon(i)=ki_incoh(i)-kf(i)
        incohana(i)=ki(i)-kf_incoh(i)
      enddo

      return
      end
